@inherits JonesComponentBase
@using Jones.AspNetCore.Utils
@using Jones.AspNetCore.Bootstrap.Types
@typeparam TResult

<div @attributes="@AdditionalAttributes" class="@Class" role="document" @ref="DialogElement">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">@Title</h5>
            @if (IsShowHeaderCloseButton)
            {
                @* <button type="button" class="btn-close" aria-label="Close" @onclick="@OnCloseClick"></button> *@
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            }
        </div>
        <CascadingValue Name="BodyContext" Value="@BodyContext" IsFixed="true">
            <div class="modal-body">
                @ChildContent
            </div>
            @if (FooterTemplate != null)
            {
                <div class="modal-footer">
                    @FooterTemplate
                </div>
            }
        </CascadingValue>
    </div>
</div>

@code {
    [CascadingParameter]
    protected Modal<TResult> Modal { get; set; }
    
    private ElementReference DialogElement { get; set; }
    
    /// <summary>
    /// 获得/设置 弹窗内容相关数据 多用于传值
    /// </summary>
    [Parameter]
    public object? BodyContext { get; set; }

    /// <summary>
    /// 获得 弹窗组件样式
    /// </summary>
    private string? Class => CssBuilder.Default("modal-dialog")
        .AddClass("modal-dialog-centered", IsCentered)
        .AddClass($"modal-{Size?.GetDisplayName()}", Size != null)
        .AddClass("modal-dialog-scrollable", IsScrolling)
        .AddClass("is-draggable", IsDraggable)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();

    /// <summary>
    /// 获得/设置 弹窗标题
    /// </summary>
    [Parameter]
    public string? Title { get; set; }
    
    /// <summary>
    /// 获得/设置 弹窗大小
    /// </summary>
    [Parameter]
    public Size? Size { get; set; }

    /// <summary>
    /// 获得/设置 是否垂直居中
    /// </summary>
    [Parameter]
    public bool IsCentered { get; set; }

    /// <summary>
    /// 获得/设置 是否弹窗正文超长时滚动
    /// </summary>
    [Parameter]
    public bool IsScrolling { get; set; }

    /// <summary>
    /// 获得/设置 是否可以拖拽弹窗
    /// </summary>
    [Parameter]
    public bool IsDraggable { get; set; }

    /// <summary>
    /// 获得/设置 是否显示 Header 关闭按钮
    /// </summary>
    [Parameter]
    public bool IsShowHeaderCloseButton { get; set; } = true;
    
    /// <summary>
    /// 获得/设置 ModalBody 组件
    /// </summary>
    [Parameter]
    public RenderFragment? ChildContent { get; set; }

    /// <summary>
    /// 获得/设置 ModalFooter 组件
    /// </summary>
    [Parameter]
    public RenderFragment? FooterTemplate { get; set; }

    private async void OnCloseClick()
    {
        await Modal.Hide();
    }
}